# 14.1. 为什么需要物理架构

硬件强大了，但数据量在增加，计算复杂度也在提高，所以增加硬件未必能解决问题。

相反，计算与计算往往不是孤立的，它们之间存在着复杂的“生产者-消费者”关系，所以软件的实际服务能力不仅受到“硬件资源”的制约，也受到了“数据短缺”和“数据争用”的制约。每个架构师都应该懂得：

> 增加硬件 = 增加计算能力 ≠ 软件的实际服务能力增强

多视图方法中，物理架构视图着重考虑运行软件的计算机、网络、硬件设施等情况，还包括如何将软件包部署（如果是嵌入系统则是烧写）到这些硬件资源上，以及它们运行时的配置情况。另外，物理架构还要考虑软件系统和包括硬件在内的整个IT系统之间是如何相互影响的，由于一部分运行质量属性需要硬件或网络的支持，所以物理架构必须关注如何配置硬件和网络来满足软件系统的可靠性、可伸缩性、持续可用性、性能、安全性等方面要求。
